import java.net.Socket;
import java.net.InetAddress;
import java.net.UnknownHostException;

import java.io.PrintWriter;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

public class TelnetClient {
  private Socket socket = null;
  public PrintWriter out = null;
  public BufferedReader in = null;
  
  public TelnetClient(InetAddress addr, int port) throws InterruptedException {
    try {
      socket = new Socket(addr, port);
      if(socket.isConnected()) {
        System.out.println("Connection established");
        out = new PrintWriter(socket.getOutputStream(), true);
        in  = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        Thread.sleep(500);
      } else {
        socket.close();
        System.out.println("Unable to establish connection");
        Thread.sleep(2000);
        System.exit(1);
      }
    } catch (UnknownHostException e) {
      System.out.println("Unable to connect to " + addr + " at port " + port);
      Thread.sleep(2000);
      System.exit(1);
    } catch (IOException e) {
      System.out.println("Unable to connect to " + addr + " at port " + port);
      Thread.sleep(2000);
      System.exit(1);
    }
  }
  
  public void send(String s) throws InterruptedException {
    Thread.sleep(100); // delay to prevent missed commands
    out.println(s);
  }
  
  public String read() throws InterruptedException {
    String s = null;
    try {
      s = in.readLine();
    } catch (IOException e) {
      System.out.println("An IO exception occured");
      Thread.sleep(2000);
      System.exit(1);
    }
    return s;
  }
  
  public void close() throws InterruptedException {
    try {
      in.close();
      out.close();
      socket.close();
    } catch (IOException e) {
      System.out.println("Unable to close connection");
      Thread.sleep(2000);
      System.exit(1);
    }
  }
}